#delimit ;
*! Author:
*! Hans-Peter Kohler
*! kohler@demogr.mpg.de
*! version 2.0 (August 20, 2000)
*! ;

program define twb2lf; 
version 6.0;
args lnf xbc $HP_xiec rho;

tempvar qi1 qi2 wi1 wi2 xb1 xb2 rhoi phi2 t1;

qui gen byte `qi1' = 2*($HP_y1!=0) - 1; 
qui gen byte `qi2' = 2*($HP_y2!=0) - 1;

qui gen double `xb1' = `xbc';
qui gen double `xb2' = `xbc';

local ii = 1;
tokenize $HP_xiva;
while `ii' <= $HP_xicn
  {;
   local ivar ``ii'';
   qui replace `xb1' = `xb1' + `xiv`ii'' * `ivar'1;
   qui replace `xb2' = `xb2' + `xiv`ii'' * `ivar'2;
   local ii = `ii' + 1;
 };

if `rho' >= .99 {;
                 scalar `rho' = .99;
               };
if `rho' <= -.99 {;
                  scalar `rho' = -.99;
                };

qui g double `wi1' = `qi1'*`xb1';
qui g double `wi2' = `qi2'*`xb1';

qui gen double `rhoi' = `qi1'*`qi2'*`rho';

qui gen double `phi2' = binorm(`wi1',`wi2',`rhoi');
qui replace `lnf' = log(`phi2') ;

end;

 

