#delimit ;
*! Author:
*! Hans-Peter Kohler
*! kohler@demogr.mpg.de
*! version 2.0 (August 20, 2000)
*! ;

program define twbolf; 
version 6.0;
args lnf xbc $HP_xiec $HP_lcec rho;

tempvar llim1 llim2 ulim1 ulim2 qxx qxl qlx qll pxx xb1 xb2;

qui gen double `xb1' = `xbc';
qui gen double `xb2' = `xbc';

local ii = 1;
tokenize $HP_xiva;
while `ii' <= $HP_xicn
  {;
   local ivar ``ii'';
   qui replace `xb1' = `xb1' + `xiv`ii'' * `ivar'1;
   qui replace `xb2' = `xb2' + `xiv`ii'' * `ivar'2;
   local ii = `ii' + 1;
 };

if `rho' >= .99 {;
                 scalar `rho' = .99;
               };
if `rho' <= -.99 {;
                  scalar `rho' = -.99;
                };

qui g double `llim1' = .;
qui g double `llim2' = .;
qui g double `ulim1' = .;
qui g double `ulim2' = .;

qui g double `qxx' = .;
qui g double `qxl' = .;
qui g double `qlx' = .;
qui g double `qll' = .;

qui replace `ulim1' = -1 * `xb1';
qui replace `ulim2' = -1 * `xb2';


local ky = 1;
while `ky' <= $HP_ymax {;

	qui replace `llim1' = `ulim1' if $HP_y1 >= `ky';
	qui replace `llim2' = `ulim2' if $HP_y2 >= `ky';
	if  `ky' < $HP_ymax {;
	qui replace `ulim1' = `ulim1' + exp(`lnc`ky'') if $HP_y1 >= `ky';
	qui replace `ulim2' = `ulim2' + exp(`lnc`ky'') if $HP_y2 >= `ky'; 
	};
	else {;
	qui replace `ulim1' = . if $HP_y1 == $HP_ymax;
	qui replace `ulim2' = . if $HP_y2 == $HP_ymax;
	};
local ky = `ky' + 1;
};

qui replace `qxx' = binorm(`ulim1',`ulim2',`rho') if $HP_y1 < $HP_ymax &
	$HP_y2 < $HP_ymax;
qui replace `qxx' = normprob(`ulim2') if $HP_y1 == $HP_ymax &
	$HP_y2 < $HP_ymax;
qui replace `qxx' = normprob(`ulim1') if $HP_y1 < $HP_ymax &
	$HP_y2 == $HP_ymax;
qui replace `qxx' = 1 if $HP_y1 == $HP_ymax &
	$HP_y2 == $HP_ymax;


qui replace `qlx' = 0 if $HP_y1 == 0;
qui replace `qlx' = binorm(`llim1',`ulim2',`rho') if $HP_y1 > 0 & 
	$HP_y2 < $HP_ymax;
qui replace `qlx' = normprob(`llim1') if $HP_y1 > 0 &
	$HP_y2 == $HP_ymax;

qui replace `qxl' = 0 if $HP_y2 == 0 ;
qui replace `qxl' = binorm(`ulim1',`llim2',`rho') if $HP_y1 < $HP_ymax &
	$HP_y2 > 0;
qui replace `qxl' = normprob(`llim2') if $HP_y1 == $HP_ymax &
	$HP_y2 > 0;

qui replace `qll' = 0 if ($HP_y1 == 0 | $HP_y2 == 0);
qui replace `qll' = binorm(`llim1',`llim2',`rho') if ($HP_y1 > 0 & 
	$HP_y2 > 0);

qui g double `pxx' = `qxx' - `qlx' - `qxl' + `qll';

qui replace `lnf' = log(`pxx'); 

end; 
 


 

